aboutsummaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorRobin Jarry <robin@jarry.cc>2022-10-18 21:41:58 +0200
committerDavid Bremner <david@tethera.net>2022-11-05 13:18:15 -0400
commit793f2980910f612fa33806ef71fa7ee35d093657 (patch)
tree693d82c511730bbf407cce43491242590f2456ba /test
parentb6565c1c54e35563843e7ddece601680170bb84a (diff)
cli: add options --offset and --limit to notmuch show
notmuch search does not output header values. However, when browsing through a large email corpus, it can be time saving to be able to paginate without running notmuch show for each message/thread. Add --offset and --limit options to notmuch show. This is inspired from commit 796b629c3b82 ("cli: add options --offset and --limit to notmuch search"). Update man page, shell completion and add a test case to ensure it works as expected. Cc: Tim Culverhouse <tim@timculverhouse.com> Cc: Tomi Ollila <tomi.ollila@iki.fi> Signed-off-by: Robin Jarry <robin@jarry.cc>
Diffstat (limited to 'test')
-rwxr-xr-xtest/T131-show-limiting.sh81
1 files changed, 81 insertions, 0 deletions
diff --git a/test/T131-show-limiting.sh b/test/T131-show-limiting.sh
new file mode 100755
index 00000000..30d1f254
--- /dev/null
+++ b/test/T131-show-limiting.sh
@@ -0,0 +1,81 @@
+#!/usr/bin/env bash
+test_description='"notmuch show" --offset and --limit parameters'
+. $(dirname "$0")/test-lib.sh || exit 1
+
+add_email_corpus
+
+show () {
+ local kind="$1"
+ shift
+ if [ "$kind" = messages ]; then
+ set -- --unthreaded "$@"
+ fi
+ notmuch show --body=false --format=text --entire-thread=false "$@" "*" |
+ sed -nre 's/^.message\{.*\<depth:0\>.*/&/p'
+}
+
+for outp in messages threads; do
+ test_begin_subtest "$outp: limit does the right thing"
+ show $outp | head -n 20 >expected
+ show $outp --limit=20 >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: concatenation of limited shows"
+ show $outp | head -n 20 >expected
+ show $outp --limit=10 >output
+ show $outp --limit=10 --offset=10 >>output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: limit larger than result set"
+ N=$(notmuch count --output=$outp "*")
+ show $outp >expected
+ show $outp --limit=$((1 + N)) >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: limit = 0"
+ test_expect_equal "$(show $outp --limit=0)" ""
+
+ test_begin_subtest "$outp: offset does the right thing"
+ # note: tail -n +N is 1-based
+ show $outp | tail -n +21 >expected
+ show $outp --offset=20 >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: offset = 0"
+ show $outp >expected
+ show $outp --offset=0 >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: negative offset"
+ show $outp | tail -n 20 >expected
+ show $outp --offset=-20 >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: negative offset"
+ show $outp | tail -n 1 >expected
+ show $outp --offset=-1 >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: negative offset combined with limit"
+ show $outp | tail -n 20 | head -n 10 >expected
+ show $outp --offset=-20 --limit=10 >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: negative offset combined with equal limit"
+ show $outp | tail -n 20 >expected
+ show $outp --offset=-20 --limit=20 >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: negative offset combined with large limit"
+ show $outp | tail -n 20 >expected
+ show $outp --offset=-20 --limit=50 >output
+ test_expect_equal_file expected output
+
+ test_begin_subtest "$outp: negative offset larger than results"
+ N=$(notmuch count --output=$outp "*")
+ show $outp >expected
+ show $outp --offset=-$((1 + N)) >output
+ test_expect_equal_file expected output
+done
+
+test_done